# Generated by Django 5.1.2 on 2024-11-07 13:21

import django.db.models.deletion
import wcd_2factor.utils.types
import wcd_settings.utils.dynamic_choices_field
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('wcd_2factor', '0002_auto_20220406_1436'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='MethodConfig',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, db_index=True, verbose_name='Created at')),
                ('updated_at', models.DateTimeField(auto_now=True, db_index=True, verbose_name='Updated at')),
                ('title', models.CharField(blank=True, max_length=1024, verbose_name='Title')),
                ('method', wcd_settings.utils.dynamic_choices_field.DynamicChoicesField(choices=[], db_index=True, max_length=128, verbose_name='Method')),
                ('config', models.JSONField(blank=True, default=dict, encoder=wcd_2factor.utils.types.TwoFactorJSONEncoder, verbose_name='Config')),
                ('is_active', models.BooleanField(db_index=True, default=True, verbose_name='Is active')),
                ('is_default', models.BooleanField(default=False, help_text='Whether this method should be used as the default for all users.', verbose_name='Is default')),
            ],
            options={
                'verbose_name': 'Method config',
                'verbose_name_plural': 'Method config',
            },
        ),
        migrations.AddField(
            model_name='confirmationstate',
            name='state',
            field=models.JSONField(blank=True, default=dict, encoder=wcd_2factor.utils.types.TwoFactorJSONEncoder, verbose_name='Config'),
        ),
        migrations.AddField(
            model_name='confirmationstate',
            name='status',
            field=models.CharField(choices=[('015-new', 'New'), ('025-in_process', 'In process'), ('085-confirmed', 'Confirmed')], default='015-new', max_length=32, verbose_name='Status'),
        ),
        migrations.AlterField(
            model_name='confirmationstate',
            name='created_at',
            field=models.DateTimeField(auto_now_add=True, db_index=True, verbose_name='Created at'),
        ),
        migrations.AlterField(
            model_name='confirmationstate',
            name='updated_at',
            field=models.DateTimeField(auto_now=True, db_index=True, verbose_name='Updated at'),
        ),
        migrations.RemoveField(
            model_name='confirmationstate',
            name='code',
        ),
        migrations.RemoveField(
            model_name='confirmationstate',
            name='is_confirmed',
        ),
        migrations.RemoveField(
            model_name='confirmationstate',
            name='meta',
        ),
        migrations.AddField(
            model_name='confirmationstate',
            name='method_config',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='wcd_2factor_confirmation_states', to='wcd_2factor.methodconfig', verbose_name='Method'),
        ),
        migrations.CreateModel(
            name='UserConfig',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, db_index=True, verbose_name='Created at')),
                ('updated_at', models.DateTimeField(auto_now=True, db_index=True, verbose_name='Updated at')),
                ('title', models.CharField(blank=True, max_length=1024, verbose_name='Title')),
                ('status', models.CharField(choices=[('015-new', 'New'), ('025-in_process', 'In process'), ('085-confirmed', 'Confirmed')], db_index=True, default='015-new', max_length=32, verbose_name='Status')),
                ('config', models.JSONField(blank=True, default=dict, encoder=wcd_2factor.utils.types.TwoFactorJSONEncoder, verbose_name='Config')),
                ('is_active', models.BooleanField(db_index=True, default=True, verbose_name='Is active')),
                ('is_default', models.BooleanField(default=False, help_text='Whether this method should be used as the default the user.', verbose_name='Is default')),
                ('method_config', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='wcd_2factor_user_connection_states', to='wcd_2factor.methodconfig', verbose_name='Method')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='wcd_2factor_user_connection_states', to=settings.AUTH_USER_MODEL, verbose_name='User')),
            ],
            options={
                'verbose_name': 'User config',
                'verbose_name_plural': 'User config',
            },
        ),
        migrations.AddField(
            model_name='confirmationstate',
            name='user_config',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='wcd_2factor_confirmation_states', to='wcd_2factor.userconfig', verbose_name='User connection'),
        ),
    ]
